package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.NotFoundException;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Allows beans configured by annotations to be reconfigured.
 */
public class ClassPathBeanDefinitionScannerCBP extends JavassistClassBytecodeProcessor {
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("org.zeroturnaround.javarebel.integration.spring");
    
    try {
      CtMethod m = ctClass.getDeclaredMethod("checkCandidate");   
      m.insertBefore("if (SpringBeanReloader.isReloadingBeanDefinitions()) {return true;}");
    } catch (NotFoundException e) {
    }
  }
}
